import _, { createContext, forwardRef, useRef, useEffect, useCallback, useState, useContext } from 'react';
import { Text } from '@contentful/f36-typography';
import { useDensity } from '@contentful/f36-utils';
import { Flex, useId, Stack, Box } from '@contentful/f36-core';
import { ErrorCircleOutlineIcon, ChevronDownIcon, DoneIcon, CloseIcon, MinusIcon } from '@contentful/f36-icons';
import { cx, css } from 'emotion';
import a from '@contentful/f36-tokens';

var Io=Object.defineProperty,ko=Object.defineProperties;var To=Object.getOwnPropertyDescriptors;var J=Object.getOwnPropertySymbols;var Te=Object.prototype.hasOwnProperty,Ee=Object.prototype.propertyIsEnumerable;var ke=(e,o,t)=>o in e?Io(e,o,{enumerable:!0,configurable:!0,writable:!0,value:t}):e[o]=t,s=(e,o)=>{for(var t in o||(o={}))Te.call(o,t)&&ke(e,t,o[t]);if(J)for(var t of J(o))Ee.call(o,t)&&ke(e,t,o[t]);return e},d=(e,o)=>ko(e,To(o));var l=(e,o)=>{var t={};for(var r in e)Te.call(e,r)&&o.indexOf(r)<0&&(t[r]=e[r]);if(e!=null&&J)for(var r of J(e))o.indexOf(r)<0&&Ee.call(e,r)&&(t[r]=e[r]);return t};var Re=()=>{},ce=createContext(void 0),So=()=>useContext(ce),P=e=>{var t,r,i,n,p;let o=So();return o?{isDisabled:(t=e.isDisabled)!=null?t:o.isDisabled,isInvalid:(r=e.isInvalid)!=null?r:o.isInvalid,isReadOnly:(i=e.isReadOnly)!=null?i:o.isReadOnly,isRequired:(n=e.isRequired)!=null?n:o.isRequired,id:(p=e.id)!=null?p:o.id,maxLength:o.maxLength,inputValue:o.inputValue,setMaxLength:o.setMaxLength||Re,setInputValue:o.setInputValue||Re}:e};var D=_.forwardRef((r,t)=>{var i=r,{testId:e="cf-ui-help-text"}=i,o=l(i,["testId"]);let{id:n}=P({}),p=useDensity();return _.createElement(Text,d(s({as:"p",fontColor:"gray500",fontSize:p==="high"?"fontSizeMHigh":"fontSizeM",lineHeight:p==="high"?"lineHeightMHigh":"lineHeightM",testId:e,id:`${n}-helptext`,marginTop:"spacingXs"},o),{ref:t}))});D.displayName="HelpText";var $=forwardRef((i,r)=>{var n=i,{children:e,testId:o="cf-ui-validation-message"}=n,t=l(n,["children","testId"]);let{id:p}=P({}),c=useDensity();return _.createElement(Flex,d(s({marginTop:"spacing2Xs"},t),{ref:r,testId:o,alignItems:"center",id:p?`${p}-validation`:void 0,"aria-live":"assertive"}),_.createElement(Flex,{marginRight:c==="high"?"spacing2Xs":"spacingXs"},_.createElement(ErrorCircleOutlineIcon,{size:c==="high"?"tiny":"small",variant:"negative","aria-hidden":"true"})),_.createElement(Text,{as:"p",fontColor:"red600",fontSize:c==="high"?"fontSizeMHigh":"fontSizeM",lineHeight:c==="high"?"lineHeightMHigh":"lineHeightM"},e))});$.displayName="ValidationMessage";var me=({isDisabled:e})=>css({alignItems:"center",background:e?a.gray300:a.colorWhite,border:`2px solid ${a.gray300}`,boxSizing:"border-box",display:"inline-flex",height:a.spacingM,justifyContent:"center",width:a.spacingM}),wo=({isDisabled:e})=>css([me({isDisabled:e}),{backgroundColor:e?a.gray300:a.colorWhite,borderRadius:a.borderRadiusSmall,"& svg":{fill:e?a.gray300:a.colorWhite},"input:indeterminate + &, input:checked + &":{backgroundColor:e?a.gray300:a.blue600,borderColor:e?a.gray300:a.blue600,"& svg":{fill:e?a.gray600:a.colorWhite}}}]),Go=({isDisabled:e})=>css([me({isDisabled:e}),{backgroundColor:e?a.gray300:a.colorWhite,borderRadius:"50%","&:before":{content:'""',borderRadius:"50%",backgroundColor:e?a.gray300:a.colorWhite,width:a.borderRadiusMedium,height:a.borderRadiusMedium},"input:checked + &":{backgroundColor:e?a.gray300:a.blue600,borderColor:e?a.gray300:a.blue600,"&:before":{backgroundColor:e?a.gray600:a.colorWhite}}}]),zo=({isDisabled:e,size:o})=>{let t=o==="small"?{height:a.spacingM,width:a.spacingXl,"&:before":{height:a.spacingS,width:a.spacingS},"input:checked + &:before":{transform:`translateX(${a.spacingM})`}}:{height:"20px",width:"40px","&:before":{height:a.spacingM,width:a.spacingM},"input:checked + &:before":{transform:"translateX(20px)"}},r={"&, input:checked + &":{background:a.gray200,borderColor:a.gray200},"&:before":{background:a.gray400},"& svg":{fill:a.gray400}};return css([me({isDisabled:e}),{background:a.gray600,borderColor:a.gray600,borderRadius:a.borderRadiusSmall,justifyContent:"space-around",position:"relative",flexShrink:0,"&:before":{background:a.colorWhite,borderRadius:`calc(${a.borderRadiusSmall}/2)`,content:'""',left:0,position:"absolute",transition:`transform ${a.transitionEasingDefault} ${a.transitionDurationDefault}`},"input:checked + &":{background:a.blue600,borderColor:a.blue600}},t,e&&r])},Oo=e=>{let{isDisabled:o,size:t}=e;return {radio:Go({isDisabled:o}),checkbox:wo({isDisabled:o}),switch:zo({isDisabled:o,size:t})}},Fe=Oo;var He=e=>{let{type:o,isIndeterminate:t,isDisabled:r,size:i="medium"}=e,n=Fe({isDisabled:r,size:i});return o==="switch"?_.createElement("span",{className:n.switch},_.createElement(DoneIcon,{size:"tiny",variant:"white"}),_.createElement(CloseIcon,{size:"tiny",variant:"white"})):_.createElement("span",{className:n[o]},o==="checkbox"&&(t?_.createElement(MinusIcon,{size:"tiny",variant:"white"}):_.createElement(DoneIcon,{size:"tiny",variant:"white"})))};var Be=e=>e==="small"?{height:a.spacingM,width:a.spacingXl}:{height:"20px",width:"40px"},_o=({size:e,type:o,density:t})=>{let r=a.spacingM;return o==="switch"&&(r=Be(e).width),{marginLeft:`calc(${r} + ${a.spacingXs})`,marginTop:0,fontSize:t==="high"?a.fontSizeMHigh:a.fontSizeM,lineHeight:t==="high"?a.lineHeightMHigh:a.lineHeightM}},Vo=({isDisabled:e,type:o,size:t,density:r})=>({wrapper:css({alignItems:"center",display:"inline-flex",position:"relative",margin:"0",columnGap:a.spacingXs}),input:css([{cursor:e?"not-allowed":"pointer",height:a.spacingM,margin:0,opacity:0,position:"absolute",width:a.spacingM,zIndex:a.zIndexDefault,"+ span":{minWidth:a.spacingM},"&:focus":{outline:"none","& + span":{boxShadow:a.glowPrimary}},"&:focus:not(:focus-visible) + span":{boxShadow:"unset"},"&:focus-visible + span":{boxShadow:a.glowPrimary}},o==="switch"&&Be(t)]),helpText:css(_o({size:t,type:o,density:r}))}),ve=Vo;function we(e,o){let Pe=e,{isChecked:t=void 0,onChange:r,onFocus:i,onBlur:n,onKeyDown:p,type:c="checkbox",value:m,isDisabled:x,isIndeterminate:y,isInvalid:b,isRequired:g=!1,id:C,willBlurOnEsc:T=!0,testId:I="cf-ui-base-checkbox",className:h="",defaultChecked:E=void 0,name:H,inputProps:k={},children:M,"aria-label":G,size:B="medium",helpText:S}=Pe,R=l(Pe,["isChecked","onChange","onFocus","onBlur","onKeyDown","type","value","isDisabled","isIndeterminate","isInvalid","isRequired","id","willBlurOnEsc","testId","className","defaultChecked","name","inputProps","children","aria-label","size","helpText"]),O=useDensity(),v=useRef(null),w=o||v,{id:pe}=P({});useEffect(()=>{w.current&&(w.current.indeterminate=y);},[y,w]);let W=ve({isDisabled:x,type:c,size:B,density:O}),ae=useCallback(z=>{z.persist(),i&&i(z);},[i]),le=useCallback(z=>{z.persist(),n&&n(z);},[n]),j=useCallback(z=>{var Ie;z.persist(),T&&z.key==="Escape"&&((Ie=w==null?void 0:w.current)==null||Ie.blur()),p&&p(z);},[T,p,w]),Z=typeof t!==void 0?t:E,F=C?`${C}-helptext`:void 0,Po=b?`${pe}-validation`:S?F:void 0;return _.createElement(Flex,{alignItems:"flex-start",flexDirection:"column",className:h},_.createElement(Text,s({as:"label",fontColor:"gray900",fontWeight:"fontWeightMedium",fontSize:O==="high"?"fontSizeMHigh":"fontSizeM",lineHeight:O==="high"?"lineHeightMHigh":"lineHeightM",className:W.wrapper,htmlFor:C,testId:I},R),_.createElement("input",d(s({},k),{"aria-label":G,checked:t,defaultChecked:E,className:W.input,type:c==="switch"?"checkbox":c,onChange:r,onFocus:ae,onBlur:le,onKeyDown:j,value:m,disabled:x,role:c,"aria-checked":y?"mixed":Z,ref:w,required:g,"aria-required":g?"true":void 0,"aria-invalid":b?"true":void 0,"aria-describedby":Po,id:C,name:H})),_.createElement(He,{type:c,isDisabled:x,isIndeterminate:y,size:B}),M),S&&_.createElement(D,{id:F,className:W.helpText},S))}we.displayName="BaseCheckbox";var N=_.forwardRef(we);var fe=createContext(void 0),jo=()=>useContext(fe),ee=e=>{var p,c,m;let o=jo();if(!o)return e;let t,r;return o.type==="checkbox"&&(t=o.value===void 0||(p=o.value)==null?void 0:p.includes(e.value),r=t!==void 0||(c=o.defaultValue)==null?void 0:c.includes(e.value)),o.type==="radio"&&(t=o.value===void 0?void 0:o.value===e.value,r=t!==void 0?void 0:o.defaultValue===e.value),{defaultChecked:r,isChecked:t,onBlur:x=>{e.onBlur&&e.onBlur(x),o.onBlur&&o.onBlur(x);},onChange:x=>{e.onChange&&e.onChange(x),o.onChange&&o.onChange(x);},name:(m=o.name)!=null?m:e.name,value:e.value}};var Jo=(e,o)=>{let S=e,{testId:t="cf-ui-checkbox",id:r,isDisabled:i,isRequired:n,isInvalid:p,children:c,onBlur:m,onChange:x,defaultChecked:y,isChecked:b,value:g,name:C}=S,T=l(S,["testId","id","isDisabled","isRequired","isInvalid","children","onBlur","onChange","defaultChecked","isChecked","value","name"]),I=useId(r,"checkbox"),h=ee({onBlur:m,onChange:x,value:g,defaultChecked:y,isChecked:b,name:C}),R=P({id:I,isDisabled:i,isInvalid:p,isRequired:n}),B=l(R,["inputValue","setInputValue","maxLength","setMaxLength","isReadOnly"]);return _.createElement(N,d(s(s(s({},B),h),T),{type:"checkbox",testId:t,ref:o}),c)},ze=_.forwardRef(Jo);var Yo=(e,o)=>{let p=e,{children:t,className:r,testId:i="cf-ui-base-checkbox-group"}=p,n=l(p,["children","className","testId"]);return _.createElement(fe.Provider,{value:n},_.createElement(Stack,{ref:o,testId:i,className:r,flexDirection:"column",alignItems:"flex-start",spacing:"spacingXs"},t))},oe=_.forwardRef(Yo);var et=(e,o)=>{let n=e,{children:t,testId:r="cf-ui-checkbox-group"}=n,i=l(n,["children","testId"]);return _.createElement(oe,s({ref:o,testId:r,type:"checkbox"},i),t)},De=_.forwardRef(et);var Ne=ze;Ne.Group=De;var rt="div";function Ve(b,y){var g=b,{as:e,isInvalid:o,isRequired:t,isDisabled:r,isReadOnly:i,children:n,marginBottom:p="spacingL",id:c,testId:m="cf-ui-form-control"}=g,x=l(g,["as","isInvalid","isRequired","isDisabled","isReadOnly","children","marginBottom","id","testId"]);let C=useId(c,"field-"),[T,I]=useState(""),[h,E]=useState(0),H=e==="fieldset"?void 0:"group",k=e||rt,M={id:C,isRequired:t,isDisabled:r,isInvalid:o,isReadOnly:i,inputValue:T,setInputValue:I,maxLength:h,setMaxLength:E};return _.createElement(ce.Provider,{value:M},_.createElement(Box,s({as:k,ref:y,role:H,testId:m,marginBottom:p},x),n))}Ve.displayName="FormControl";var Ae=_.forwardRef(Ve);function $e(){return {root:css({display:"inline-block",fontWeight:a.fontWeightMedium}),indicator:css({color:a.gray500,fontWeight:a.fontWeightNormal,marginLeft:a.spacing2Xs})}}var at="label";function qe(m,c){var x=m,{as:e,children:o,className:t,isRequired:r,requiredText:i="required",testId:n="cf-ui-form-label"}=x,p=l(x,["as","children","className","isRequired","requiredText","testId"]);let y=useDensity(),b=$e(),g=P({isRequired:r}),C=g.id?g.id+"-label":void 0,T=e!=="legend"?{htmlFor:p.htmlFor||g.id}:{};return _.createElement(Text,d(s(d(s({as:e||at,marginBottom:"spacingXs"},p),{fontColor:"gray900",id:C}),T),{className:cx(b.root,t),ref:c,testId:n,fontSize:y==="high"?"fontSizeMHigh":"fontSizeM",lineHeight:y==="high"?"lineHeightMHigh":"lineHeightM"}),o,g.isRequired&&_.createElement("span",{className:b.indicator},"(",i,")"))}qe.displayName="FormLabel";var re=forwardRef(qe);function Ue(){return {root:css({flexShrink:0,paddingLeft:a.spacingM,textAlign:"right"})}}var X=forwardRef((i,r)=>{var n=i,{testId:e="cf-ui-counter",className:o}=n,t=l(n,["testId","className"]);let{maxLength:p,inputValue:c}=P({}),m=Ue();return !!p&&_.createElement(Text,d(s({as:"p",fontColor:"gray700",fontSize:"fontSizeM",testId:e,marginTop:"spacingXs"},t),{className:cx(m.root,o),ref:r}),c.length," / ",p)});X.displayName="Counter";var q=Ae;q.Label=re;q.ValidationMessage=$;q.HelpText=D;q.Counter=X;var ht=(e,o)=>{let S=e,{testId:t="cf-ui-radio-button",id:r,isDisabled:i,isInvalid:n,isRequired:p,children:c,onBlur:m,onChange:x,defaultChecked:y,isChecked:b,value:g,name:C}=S,T=l(S,["testId","id","isDisabled","isInvalid","isRequired","children","onBlur","onChange","defaultChecked","isChecked","value","name"]),I=useId(r,"radio"),h=ee({onBlur:m,onChange:x,value:g,defaultChecked:y,isChecked:b,name:C}),R=P({id:I,isDisabled:i,isInvalid:n,isRequired:p}),B=l(R,["inputValue","setInputValue","maxLength","setMaxLength","isReadOnly"]);return _.createElement(N,d(s(s(s({},B),T),h),{type:"radio",testId:t,ref:o}),c)},je=_.forwardRef(ht);var gt=(e,o)=>{let n=e,{children:t,testId:r="cf-ui-radio-group"}=n,i=l(n,["children","testId"]);return _.createElement(oe,s({ref:o,testId:r,type:"radio"},i),t)},Je=_.forwardRef(gt);var Qe=je;Qe.Group=Je;var yt=({size:e,density:o})=>{let t=o==="high";return e==="small"?{padding:a.spacingXs,minHeight:t?a.spacingL:a.spacingXl,maxHeight:t?a.spacingL:a.spacingXl}:{padding:t?a.spacingXs:`10px ${a.spacingS}`,minHeight:t?a.spacingXl:"40px",maxHeight:t?a.spacingXl:"40px"}},Ye=({isDisabled:e,isInvalid:o,zIndexBase:t=a.zIndexDefault})=>e||o?t+1:t,bt=({isDisabled:e,isInvalid:o})=>e?{borderColor:a.gray300,boxShadow:"none"}:o?{borderColor:a.red600,boxShadow:a.glowNegative}:{},Ct=({as:e,isDisabled:o,isInvalid:t,size:r,resize:i,density:n="low"})=>{let p={low:{borderRadius:a.borderRadiusMedium,lineHeight:a.lineHeightM,fontSize:a.fontSizeM},high:{borderRadius:a.borderRadiusSmall,lineHeight:a.lineHeightMHigh,fontSize:a.fontSizeMHigh}};return {rootComponentWithIcon:css({position:"relative",display:"flex",width:"100%",zIndex:Ye({isDisabled:o,isInvalid:t})}),input:css(d(s(s({outline:"none",boxShadow:a.insetBoxShadowDefault,boxSizing:"border-box",backgroundColor:o?a.gray100:a.colorWhite,border:`1px solid ${t?a.red600:a.gray300}`,color:a.gray700,fontFamily:a.fontStackPrimary,margin:0,cursor:o?"not-allowed":"auto",width:"100%",zIndex:Ye({isDisabled:o,isInvalid:t})},p[n]),e==="textarea"?{resize:i}:yt({size:r,density:n})),{"&::placeholder":{color:a.gray500},"&:active, &:active:hover, &:focus":s({borderColor:a.blue600,boxShadow:a.glowPrimary},bt({isDisabled:o,isInvalid:t}))})),inputWithIcon:css({paddingLeft:a.spacingXl}),iconPlaceholder:css({position:"absolute",pointerEvents:"none",top:0,bottom:0,left:r==="small"?a.spacingXs:a.spacingS,display:"flex",alignItems:"center",zIndex:a.zIndexDefault})}},eo=Ct;var kt="input";function to(e,o){let Z=e,{as:t=kt,className:r,isDisabled:i,isReadOnly:n,isRequired:p,isInvalid:c,id:m,name:x,onBlur:y,onChange:b,onFocus:g,onKeyDown:C,testId:T="cf-ui-base-input",type:I="text",value:h=void 0,placeholder:E,willBlurOnEsc:H=!0,style:k,icon:M,defaultValue:G,size:B="medium",resize:S="vertical"}=Z,R=l(Z,["as","className","isDisabled","isReadOnly","isRequired","isInvalid","id","name","onBlur","onChange","onFocus","onKeyDown","testId","type","value","placeholder","willBlurOnEsc","style","icon","defaultValue","size","resize"]),O=useDensity(),v=eo({as:t,isDisabled:i,isInvalid:c,size:B,resize:S,density:O}),w=useCallback(F=>{F.persist(),g&&g(F);},[g]),pe=useCallback(F=>{F.persist(),!(i||n)&&b&&b(F);},[b,i,n]),W=useCallback(F=>{F.persist(),C&&C(F),F.nativeEvent.code==="Escape"&&H&&F.currentTarget.blur();},[H,C]),ae=M&&_.createElement(Box,{as:"span",className:v.iconPlaceholder},_.cloneElement(M,{size:"tiny",variant:"muted","aria-hidden":!0})),le=t,j=F=>_.createElement(le,d(s({},R),{value:h,defaultValue:G,"data-test-id":T,style:k,placeholder:E,className:cx(v.input,F,r),name:x,type:I,ref:o,id:m,readOnly:n,"aria-readonly":n?"true":void 0,"aria-required":p?"true":void 0,"aria-invalid":c?"true":void 0,"aria-describedby":m?`${m}-${c?"validation":"helptext"}`:void 0,disabled:i,required:p,onChange:pe,onBlur:y,onKeyDown:W,onFocus:w,size:B}));return M?_.createElement(Box,{as:"div",className:v.rootComponentWithIcon},j(v.inputWithIcon),ae):j()}to.displayName="BaseInput";var K=_.forwardRef(to);var Rt=(I,T)=>{var h=I,{className:e,testId:o="cf-ui-text-input",id:t,value:r,defaultValue:i,onChange:n,onFocus:p,isInvalid:c,isDisabled:m,isRequired:x,isReadOnly:y,size:b="medium",maxLength:g}=h,C=l(h,["className","testId","id","value","defaultValue","onChange","onFocus","isInvalid","isDisabled","isRequired","isReadOnly","size","maxLength"]);let O=P({id:t,isInvalid:c,isDisabled:m,isRequired:x,isReadOnly:y}),{setMaxLength:E,maxLength:H,setInputValue:k,inputValue:M}=O,G=l(O,["setMaxLength","maxLength","setInputValue","inputValue"]);useEffect(()=>{var v;g!==void 0&&typeof E=="function"&&(E(g),k((v=r!=null?r:i)!=null?v:""));},[g,E,k,i,r]);let B=v=>{typeof k=="function"&&k(v.target.value),n==null||n(v);},S=useRef(null),R=T||S;return _.createElement(K,d(s(s({type:"text"},C),G),{testId:o,ref:R,onChange:g?B:n,onFocus:p,as:"input",className:e,value:r,defaultValue:i,size:b,maxLength:g}))},no=_.forwardRef(Rt);var St=({spacing:e,density:o})=>{let t=o==="high"?a.borderRadiusSmall:a.borderRadiusMedium,r=o==="high"?{"& svg":{width:"14px",height:"14px"}}:{};return e!=="none"?css(s({"& button, & input":{borderRadius:t,height:"auto"}},r)):css(d(s({position:"relative","& button, & input":{borderRadius:"0 !important",height:"auto"}},r),{"& > *":{marginRight:"-1px !important","&:not(:focus), & button:not(:focus)":{boxShadow:"none !important"},"&:first-child, &:first-child > input, &:first-child button":{borderBottomLeftRadius:`${t} !important`,borderTopLeftRadius:`${t} !important`},"&:last-child, &:last-child > input, &:last-child button":{borderBottomRightRadius:`${t} !important`,borderTopRightRadius:`${t} !important`,marginRight:"0 !important"},"&:focus, &:focus-within":{zIndex:a.zIndexDefault+1}}}))},so=({spacing:e,density:o})=>({inputGroup:St({spacing:e,density:o})});var Ht=(e,o)=>{let m=e,{children:t,className:r,spacing:i="none"}=m,n=l(m,["children","className","spacing"]),p=useDensity(),c=so({spacing:i,density:p});return _.createElement(Stack,d(s({},n),{spacing:i,ref:o,fullWidth:!0,className:cx(c.inputGroup,r)}),t)},ao=_.forwardRef(Ht);var lo=no;lo.Group=ao;var Bt=(e,o)=>{let I=e,{testId:t="cf-ui-switch",id:r,isDisabled:i,isInvalid:n,isRequired:p,children:c}=I,m=l(I,["testId","id","isDisabled","isInvalid","isRequired","children"]),h=P({id:r,isDisabled:i,isInvalid:n,isRequired:p}),T=l(h,["inputValue","setInputValue","maxLength","setMaxLength","isReadOnly"]);return _.createElement(N,d(s(s({},T),m),{testId:t,type:"switch",ref:o}),c)},mo=_.forwardRef(Bt);var uo=()=>({root:css({padding:`10px ${a.spacingS}`}),error:css({"&:focus":{borderColor:a.red600,boxShadow:a.glowNegative}}),disabled:css({"&:focus":{borderColor:a.gray300,boxShadow:"none"}})});var Gt=(T,C)=>{var I=T,{className:e,isDisabled:o,isInvalid:t,isRequired:r,isReadOnly:i,onChange:n,testId:p="cf-ui-textarea",id:c,resize:m="vertical",maxLength:x,value:y,defaultValue:b}=I,g=l(I,["className","isDisabled","isInvalid","isRequired","isReadOnly","onChange","testId","id","resize","maxLength","value","defaultValue"]);let h=uo(),S=P({id:c,isInvalid:t,isDisabled:o,isRequired:r,isReadOnly:i}),{setMaxLength:E,maxLength:H,setInputValue:k,inputValue:M}=S,G=l(S,["setMaxLength","maxLength","setInputValue","inputValue"]);useEffect(()=>{var R;x!==void 0&&typeof E=="function"&&(E(x),k((R=y!=null?y:b)!=null?R:""));},[b,x,k,E,y]);let B=R=>{typeof k=="function"&&k(R.target.value),n==null||n(R);};return _.createElement(K,d(s(s({},g),G),{defaultValue:b,value:y,testId:p,as:"textarea",ref:C,className:cx(h.root,e,{[h.disabled]:o,[h.error]:t}),maxLength:x,resize:m,onChange:x?B:n}))},xo=_.forwardRef(Gt);var Ce=r=>{var i=r,{testId:e="cf-ui-select-option",isDisabled:o}=i,t=l(i,["testId","isDisabled"]);return _.createElement("option",d(s({"data-test-id":e},t),{disabled:o}))};function ho({isInvalid:e,isDisabled:o,size:t,density:r}){let i=()=>{switch(!0){case t==="small":return {padding:`${a.spacing2Xs} ${a.spacingL} ${a.spacing2Xs} ${a.spacingXs}`,height:"32px"};case(t==="medium"&&r==="high"):return {padding:`${a.spacing2Xs} ${a.spacingL} ${a.spacing2Xs} ${a.spacingXs}`,height:"32px",fontSize:a.fontSizeMHigh,lineHeight:a.lineHeightMHigh,borderRadius:a.borderRadiusSmall};case(t==="medium"||r==="low"):default:return {padding:`10px ${a.spacingL} 10px ${a.spacingS}`,height:"40px"}}},n=css({width:"100%",display:"block",appearance:"none",backgroundColor:a.colorWhite,color:a.gray700,fontSize:a.fontSizeM,lineHeight:a.lineHeightM,fontFamily:a.fontStackPrimary,borderRadius:a.borderRadiusMedium,boxShadow:a.insetBoxShadowDefault,outline:"none",border:`1px solid ${a.gray300}`,cursor:"pointer",overflow:"hidden",textOverflow:"ellipsis","&::placeholder":{color:a.gray500},"&:focus":{outline:"none",boxShadow:a.glowPrimary,borderColor:a.blue500},"&:-moz-focusring":{color:"transparent",textShadow:"0 0 0 #000"},"&::-ms-expand":{display:"none"}}),p=css({backgroundColor:a.gray100,cursor:"not-allowed",color:a.gray600,"&:focus, &:active":{borderColor:a.gray300}}),c=css({borderColor:o?a.red300:a.red600,"&:focus":{borderColor:a.red600,boxShadow:a.glowNegative}});return {wrapper:css({position:"relative",display:"block",width:"auto"}),select:css([n,i(),o&&p,e&&c]),icon:css({position:"absolute",right:a.spacingXs,top:"50%",marginTop:"-8px",pointerEvents:"none"})}}var Vt=(T,C)=>{var I=T,{id:e,children:o,className:t,isInvalid:r,isDisabled:i,isRequired:n,testId:p="cf-ui-select",willBlurOnEsc:c=!0,onKeyDown:m,size:x="medium",value:y=void 0,defaultValue:b=void 0}=I,g=l(I,["id","children","className","isInvalid","isDisabled","isRequired","testId","willBlurOnEsc","onKeyDown","size","value","defaultValue"]);let h=P({isDisabled:i,isInvalid:r,isRequired:n,id:e}),E=useDensity(),H=ho({isDisabled:h.isDisabled,isInvalid:h.isInvalid,size:x,density:E}),k=useCallback(M=>{M.nativeEvent.code==="Escape"&&c&&M.currentTarget.blur(),m&&m(M);},[m,c]);return _.createElement("div",{className:cx(H.wrapper,t)},_.createElement("select",d(s({},g),{id:h.id,"data-test-id":p,className:H.select,onKeyDown:k,required:h.isRequired,"aria-required":h.isRequired?"true":void 0,"aria-invalid":h.isInvalid?!0:void 0,"aria-describedby":h.id?`${h.id}-${h.isInvalid?"validation":"helptext"}`:void 0,disabled:h.isDisabled,defaultValue:b,value:y,ref:C}),o),_.createElement(ChevronDownIcon,{className:H.icon,variant:"muted"}))},go=_.forwardRef(Vt);var yo=go;yo.Option=Ce;function bo(n,i){var p=n,{children:e,onSubmit:o,testId:t="cf-ui-form-label"}=p,r=l(p,["children","onSubmit","testId"]);let c=useCallback(m=>{m.preventDefault(),o&&o(m);},[o]);return _.createElement("form",s({ref:i,"data-test-id":t,onSubmit:c},r),e)}bo.displayName="Form";var Co=forwardRef(bo);

export { Ne as Checkbox, X as Counter, Co as Form, q as FormControl, re as FormLabel, D as HelpText, Ce as Option, Qe as Radio, yo as Select, mo as Switch, lo as TextInput, xo as Textarea, $ as ValidationMessage };
//# sourceMappingURL=out.js.map
//# sourceMappingURL=index.js.map